#!/bin/sh

sa='./standalone'
cf='campaign_conformance_test.txt'
tv='test_vec'

ascii='-a --strip-trailing-cr'

echo
echo "Test options:"
echo
echo "1) eCall modem core"
echo "2) eCall modem core with HLACK transmission"
echo "3) eCall modem core with IVS initiated signaling"
echo "*) Exit"
echo
echo -n "Selection: "

read choice

case $choice in
  1) base=core;      ts=psap;;
  2) base=corehlack; ts=psap;;
  3) base=corepush;  ts=ivs;;
  *) exit;;
esac

mkdir -p ./out

# Running IVS...
$sa -m ivs    -t $ts -c $tv/$cf -i $tv/${base}_pcm  -o out/${base}_pcm
$sa -m ivsrx  -t $ts -c $tv/$cf -i $tv/${base}_pcm  -o out/${base}_port
$sa -m ivstx  -t $ts -c $tv/$cf -i $tv/${base}_port -o out/${base}_pcmtx
echo

# Running PSAP...
$sa -m psap   -t $ts -c $tv/$cf -i $tv/${base}_pcm  -o out/${base}_pcm
$sa -m psaprx -t $ts -c $tv/$cf -i $tv/${base}_pcm  -o out/${base}_port
$sa -m psaptx -t $ts -c $tv/$cf -i $tv/${base}_port -o out/${base}_pcmtx
echo

x=1
while [ $x -le 8 ]
do
  echo CASE $x:

  echo Checking PCM data IVS...
  diff -s $tv/${base}_pcmulin$x.pcm out/${base}_pcmulin$x.out
  diff -s $tv/${base}_pcmulin$x.pcm out/${base}_pcmtxulin$x.out

  echo Checking PCM data PSAP...
  diff -s $tv/${base}_pcmdlin$x.pcm out/${base}_pcmdlin$x.out
  diff -s $tv/${base}_pcmdlin$x.pcm out/${base}_pcmtxdlin$x.out

  x=`expr $x + 1`
  echo
done

x=1
while [ $x -le 8 ]
do
  echo CASE $x:

  echo Checking PORT data IVS...
  diff -s $ascii $tv/${base}_portivsrx$x.txt out/${base}_portivsrx$x.txt

  echo Checking PORT data PSAP...
  diff -s $ascii $tv/${base}_portpsaprx$x.txt out/${base}_portpsaprx$x.txt

  x=`expr $x + 1`
  echo
done
